//
//  YGAppDelegate.m
//  FetchTest
//
//  Created by yagom on 13. 10. 11..
//  Copyright (c) 2013년 yagom. All rights reserved.
//

#import "YGAppDelegate.h"

@implementation YGAppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // Background Fetch를 초기화 시킵니다.
    // 옵션은 가장 짧은 주기로 계속해서 Fetch를 하도록 주었습니다.
    [[UIApplication sharedApplication] setMinimumBackgroundFetchInterval:UIApplicationBackgroundFetchIntervalMinimum];
    
    return YES;
}

// Background Fetch가 실행 될 때 호출되는 Delegate 메소드 입니다.
- (void)application:(UIApplication *)application performFetchWithCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler
{
    NSLog(@"Received Background Fetch");
    
    // 데이터를 받아오거나 호출을 할 URL
    NSURL *yagomURL = [NSURL URLWithString:@"http://blog.yagom.net"];
    
    // URL 객체가 잘 만들어 졌으면
    if (yagomURL != nil)
    {
        // URL로 호출할 때 쓰일 request 객체입니다.
        NSURLRequest *request = [NSURLRequest requestWithURL:yagomURL];
        
        // 데이터 로드 실패 시 주소를 받아올 에러 포인터
        NSError *error = nil;
        
        // 해당 URL의 데이터를 가져옵니다.
        NSData *data = [NSURLConnection sendSynchronousRequest:request returningResponse:nil error:&error];
        
        // 데이터 로딩이 되었으면
        if (data != nil)
        {
            // 배지 숫자를 올려줍니다. 백그라운드에서 실행되고 있기 때문에 배지로 뭔가 실행이 되었다는 것을 알게 해줍니다.
            [UIApplication sharedApplication].applicationIconBadgeNumber++;

            // 성공했음을 알립니다.
            completionHandler(UIBackgroundFetchResultNewData);
        }
        else
        {
            // 에러를 로그로 찍어보고
            NSLog(@"%@", error);
            
            // 실패했음을 알립니다.
            completionHandler(UIBackgroundFetchResultFailed);
        }
    }
    else
    {
        // 실패했음을 알립니다.
        completionHandler(UIBackgroundFetchResultFailed);
    }
}

							
- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
